Program LastNode;

Uses Dos, Crt;

{$M 8196,0,0}
{$I LASTCALL.INC}

Const
      garcho = '  ';
      Programa = 'LastNode v1.01';
      ExtraInfo = '(C) 1993 HighToro Research, BA (4:900/354@fidonet.org)';
      maximonodos = 30;

Var
   Configuracion : String[60];
   FD_Last : File of ActivityREC;
   FD_Reg : ActivityREC;
   Nodo : String[16];
   Vector : Array[1..maximonodos] of string;
   NodoVec: Array[1..maximonodos] of string[16];
   EjecVec: Array[1..maximonodos] of string[240];
   cantidadnodos : integer;
   i: integer;
   Debug : boolean;



Function FixPath(Palabra: String): String;
Begin
   if copy(Palabra,length(Palabra),1) <> '\' then
      Palabra := Palabra + '\';
   FixPath := Palabra;
End;




function IntToStr(i: word): string;
var s: string;
begin
  Str(i, s);
  IntToStr := s;
end;





Function Levantar(s:string):string;
var
  i : Integer;
begin
     for i := 1 to Length(s) do
         s[i] := UpCase(s[i]);
     levantar:=s;
End;




Function Dir_Exe: String;
Var
   Temp: String;
   i,L,marca: Integer;
Begin
     marca := 0;
     Temp := Paramstr(0);
     L:=length(Temp);
     For i := 1 to L do
         If copy(Temp,i,1) = '\' then marca := i;

     Temp := Copy(Temp,1,marca);
     Dir_Exe := Temp;
End;





Procedure Lee_Configuracion;

Const
     ArchiConf = 'LASTNODE.CTL';
Var
    f : text;
    i, primerespacio, pepe, moco : integer;
Begin
     Assign(f,Dir_Exe+ArchiConf);
     {$i-} Reset(f); {$i+}
     if ioresult <> 0 then
        begin
             writeln('Error: No encuentro el archivo de control ',Dir_Exe+Archiconf,'.');
             halt;
        end;

     For i:=1 to maximonodos do Vector[i]:='--' + IntToStr(i) + '--';
     For i:=1 to maximonodos do NodoVec[i]:='//' + IntToStr(i) + '//';
     For i:=1 to maximonodos do EjecVec[i]:='##' + IntToStr(i) + '##';
     i:=0;

     while not eof(f) do
         Begin
              i:=i+1;
              if i > maximonodos then
                begin
                    writeln('Error: Slo puedo soportar hasta ',maximonodos,' nodos.');
                    Close(f);
                    halt;
                end;

              Readln(f,Vector[i]);
              moco:=pos(';',Vector[i]);
              if (moco<>0) then
                 Vector[i][0]:=char(moco-1);
                 (*
              writeln('Nicolai: ',Vector[i]);
              *)

              pepe:=1;
              while ((Vector[i][pepe]=' ') and
                (pepe<=length(Vector[i]))) do
                  inc(pepe);

              NodoVec[i]:='';
              while ((Vector[i][pepe]<>' ') and
                (pepe<=length(Vector[i]))) do
              begin
                NodoVec[i]:=NodoVec[i]+Vector[i][pepe];
                inc(pepe);
              end;

              while ((Vector[i][pepe]=' ') and
                (pepe<=length(Vector[i]))) do
                inc(pepe);

              EjecVec[i]:='';
              while (pepe<=length(Vector[i])) do
              begin
                EjecVec[i]:=EjecVec[i]+Vector[i][pepe];
                inc(pepe);
              end;

              EjecVec[i] := Levantar(EjecVec[i]);

              if ((NodoVec[i]='') or (EjecVec[i]='')) then
                dec(i);
         End;
     close(f);

     cantidadnodos := i;

     if Debug = True then
        Begin
              for i:=1 to cantidadnodos do
                  begin
                       Write('Nodo : [',NodoVec[i],']    ');
                       Writeln('Comando : [',EjecVec[i],']');
                  end;
              writeln;
              writeln(garcho,'Cantidad de nodos en el CTL   :   [',cantidadnodos:3,']');
              writeln(garcho,'Mxima capacidad soportada    :   [',maximonodos:3,']');
              writeln;
              writeln(garcho,'PAUSA',garcho,'Pulse <Enter>  para proseguir.');
              readln;
              writeln;
        End;
End;





Procedure Ejecucion(Ejecutar: String);
Begin
     Swapvectors;
     Exec(GetEnv('COMSPEC'),'/C '+Ejecutar);
     SwapVectors;
End;





Begin
     Writeln; Writeln(Programa,' ',ExtraInfo); Writeln;

     Debug := False;
     if Levantar(ParamStr(1)) = '/D' then Debug := True
     else
        if Paramcount > 0 then
           begin
                writeln('Programado en Buenos Aires por Carlos Jaacks en enero de 1993.');
                writeln('Agradezco a Nicolai Kuzminski por su no solicitada colaboracin');
                writeln('en el procedimiento de lectura del archivo de control. :-)');
                writeln;
                writeln(' Another Ultimate Hub Utility ');
                halt;
           end;

     Configuracion := GetEnv('FD');
     if length(Configuracion) < 1 then
        begin
             writeln('Error: Este programa est diseado para trabajar bajo ambiente FrontDoor.');
             writeln('       No encuentro la variable FD definida en el entorno.');
             writeln('       Ej.: SET FD = C:\FD'); writeln;
             halt;
        end;

     Configuracion := FixPath(Configuracion);
     Configuracion := Levantar (Configuracion + 'LASTCALL.FD');

     Assign(FD_Last,Configuracion);
     {$I-}
     Reset(FD_Last);
     {$I+}

     if IoResult <> 0 then
        begin
             writeln('Error: Queriendo abrir para lectura el archivo ',Configuracion);
             halt;
        end;

     Read(FD_Last,FD_Reg);

     Close(FD_Last);

     with FD_Reg do
          Begin
               with LastIn do
                    Begin
                         writeln(garcho,'Sistema     :   ',SystemName);
                         Nodo := IntToStr(Zone) + ':' + IntToStr(Net) + '/' + IntToStr(Node) + '.' + IntToStr(Point);
                         writeln(garcho,'Direccin   :   ',Nodo);
                    End;
          End;

     Writeln;

     Lee_Configuracion;

     For i:=1 to cantidadnodos do
            begin
                 if NodoVec[i] = Nodo then
                    Begin
                         writeln(garcho,'Comando a ejecutar : ',EjecVec[i]);
                         writeln;
                         Ejecucion(EjecVec[i]);
                         writeln;
                    End;
            end;

     Writeln(garcho,Programa,' Fin de ejecucin...'); Writeln;

End.
